import processing.core.*; 
import processing.xml.*; 

import java.awt.event.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class FotoFasto extends PApplet {

//lab18 Elodie Rafalimanana 17/04/09

PImage img, previousFrame, modifiedImg;
Boolean loaded = false;
Boolean saved = false;
Boolean about = false;

Menu mainMenu;
ArrayList menuButtons = null;
Transform transform;
Filter filter;

int buttonSize = 120;
int menuHeight = (int)(buttonSize/3);
int menuWidth = (int)(buttonSize);
int menuPressed = -1, submenuPressed = -1;//Otherwise set to 0 automatically if not set ..bug

public void setup () {
  smooth();
  mainMenu = new Menu(buttonSize);
  transform = new Transform();
  filter = new Filter();
  size(6*buttonSize,6*buttonSize);
  frame.setResizable(true); //Allows to resize the display window for a better view of the image
  background(0,57,66);
  
  mainMenu.writeCredits(); 

}

public void draw(){
  
  if(loaded){  
    menuButtons = new ArrayList(Arrays.asList("Open image","Save image", "Original", "Filters", "Transform", "About"));//when an image is loaded the full menu appears
  }
  else{
    menuButtons = new ArrayList(Arrays.asList("Open image"));//at start only the open button is present
  }

 menuWidth = menuButtons.size()*buttonSize;

//Switch for menu and submenu
switch(menuPressed){//menuPressed comes from the mousePressed function normally img is already loaded

case 0://open button, displays the loaded image or go back button
 if(loaded){//means img!= null
   previousFrame = previousFrame != null ? previousFrame : img; //if the image has just been loaded previous frame should be the loaded image, otherwise previous frame is the modified image
    if(about == false){//case button is not go back button, in normal mode the loop must be active
      loop();
    }
    image(previousFrame, 0, 0,width,height);//draws the image
 }
break;
 
case 1://save
   previousFrame = previousFrame != null ? previousFrame : img;//previous frame exists if you have clicked on save button or about button, if you've just loaded the image previous frame = img
   image(previousFrame, 0, 0,width,height);
   if(saved == false){
     String savePath = selectOutput("Save image as");
     if(savePath != null){
       save(savePath);
       saved = true;
     }
     else{//you cancelled the saving
       saved = false;
       menuPressed = -1;
     }   
   }
break;

case 2://original button, displays the original image
  image(img, 0, 0,width,height);
  previousFrame=img;
break;
 
case 3://Filters
menuHeight = buttonSize/3;//reset the menu height when the submenus are not displayed, so submenus don't trigger if not visible
  switch(submenuPressed){
     ////////////////// //Filters Menu//////////////////////
    case 0 :
      previousFrame =  previousFrame != null ? previousFrame : img;
      image(previousFrame,0,0,width,height);//allow to wipe the other submenu if it was open
      String[] filterButtons = {"Exit menu", "B&W", "Blur", "Threshold", "Sepia", "Invert", "Posterize", "Warhol1", "Warhol2"};
      mainMenu.createSubmenu(filterButtons, menuPressed);
      menuHeight=(filterButtons.length+1)*buttonSize/3;//+1 = the parent menu button Filters     
    break;
    ////////////////// //Exit Menu//////////////////////
    case 1 :
      previousFrame =  previousFrame != null ? previousFrame : img;
      image(previousFrame,0,0,width,height);
    break;
    ////////////////// //B&W Filter//////////////////////
    case 2:
       filter.bw(img);
       previousFrame = filter.modifiedImg;
    break;
    ////////////////// //Blur Filter//////////////////////
    case 3:
       filter.blur(img);
       previousFrame = filter.modifiedImg;   
    break;
    ////////////////// //Threshold Filter//////////////////////
    case 4:
       filter.threshold(img);
       previousFrame = filter.modifiedImg;
    break;
    ////////////////// //Sepia Filter//////////////////////
    case 5:
       filter.sepia(img);
       previousFrame = filter.modifiedImg;
    break;
    ////////////////// //Invert Filter//////////////////////
    case 6:
       filter.invert(img);
       previousFrame = filter.modifiedImg;
    break;
    ////////////////////Posterize Filter////////////////////
    case 7:
       filter.posterize(img);
       previousFrame = filter.modifiedImg;
    break;
    case 8:
    ///////////////////////Warhol1 Filter//////////////////  
       filter.warhol1(img);
       previousFrame = filter.modifiedImg;  
    break;
    ////////////////Warhol2 Filter////////////////////
    case 9:
       filter.warhol2(img);
       previousFrame = filter.modifiedImg;
    break;
  }  
break;//break case 3 filter menu
//*********************Transform menu********************** 
 
 case 4://Transform menu
  menuHeight = buttonSize/3;//reset the menu height when the submenus are not displayed, so submenus don't trigger if not visible
   switch(submenuPressed){
     ///////////////////////// Tansform Menu ////////////////////////// 
     case 0:
        previousFrame =  previousFrame != null ? previousFrame : img;
        image(previousFrame,0,0,width,height);//allow to wipe the other submenu if it was open
        String[] transformButtons = {"Exit menu", "Mirror", "Rotate", "Flip"};
        mainMenu.createSubmenu(transformButtons, menuPressed);
        menuHeight=(transformButtons.length+1)*buttonSize/3;//+1 = the parent menu button Transform
     break;
   ///////////////////////// Exit Menu ////////////////////////// 
     case 1:
       previousFrame = previousFrame != null ? previousFrame : img;
       image(previousFrame,0,0,width,height);
     break;
   ///////////////////////// Mirror  //////////////////////////// 
     case 2:
       transform.mirror(img);
       previousFrame = transform.modifiedImg;
     break;
  ///////////////////////// Rotate ////////////////////////////
     case 3:
        transform.rotate(img);
        previousFrame = transform.modifiedImg;
     break;
  ///////////////////////// Flip ////////////////////////////
     case 4:
       transform.flip(img);
       previousFrame = transform.modifiedImg;
     break;
   }     

 break;// break case 4 transform menu;
 case 5://about button
      background(0,57,66);
      mainMenu.writeCredits();
      about = true;
      menuButtons = new ArrayList(Arrays.asList("Go Back"));
 break;
}//end switch menus and submenus
  
  if(menuButtons != null){//draws all the menu buttons
    mainMenu.createMainMenu(menuButtons);
  }

}//end draw

//Instead of using the boolean mousePressed in the draw function, 
//I used the function mouseReleased because I needed the draw function
//to draw continually the images even when the mouse is not pressed for example when the display window is resized
//I used mouseReleased instead of mousePressed because of a bug that makes the app to freeze when calling selectInput in mousePressed
public void mouseReleased(){
  if(mouseY < menuHeight && mouseX < menuWidth){
   menuPressed = (int)(mouseX / buttonSize);//determines which menu you clicked horizontally
   submenuPressed = (int) (mouseY /(buttonSize/3));//determines which submenu you clicked vertically
  //sent to draw automatically
  if(menuPressed == 0){//if you pressed the first button = open or go back button
      if(about == false){//first button is the open button
        String loadPath = selectInput("Select an image to process");  // Opens file chooser
        if (loadPath != null) {
          // If a file was selected
          img=loadImage(loadPath);
          if(img!=null){
            if(img.width >= 6*buttonSize){
              frame.setSize(img.width, img.height);
            }
            else{
              frame.setSize(6*buttonSize, img.height*6*buttonSize/img.width);
            }
            loaded = true;
            previousFrame = null;//so that when a new image is loaded it draws the new image but not the previous frame for ex. if you came from the about section or just saved an image 
          }
        }   
      }
      else{//first button is go back button, you clicked the go back button, we leave the about mode and redraw the previous state
          if(about){
            about = false;
            redraw();//because noLoop when pressing the about button
          }      
      }
  }//end if menuPressed 0
  if(menuPressed == 1){//if you pressed the save button
    if(saved){
      saved = false;
    }
  }//end if menuPressed 1

}//end if mouseY

}







class Filter {
  PImage modifiedImg;
  int c, cc;
  float r, g, b, av, th, th1, th2, th3, th4, th5, th6;

  Filter() {
  }

  public void init(PImage img) {
    img.loadPixels();
    this.modifiedImg = createImage(img.width, img.height, RGB);
    this.modifiedImg.loadPixels();
  }

  public void bw(PImage img) {
    this.init(img);

    for (int i=0;i<img.pixels.length;i++) {
      c=img.pixels[i];
      r = red (c);
      b = blue (c);
      g = green (c);
      av=(r+g+b)/3;
      cc=color(av, av, av);
      //cc=color(av,av,av);
      this.modifiedImg.pixels[i]=cc;
    }//end for

    this.modifiedImg.updatePixels();
    image(this.modifiedImg, 0, 0, width, height);
  }

  public void blur(PImage img) {
    this.init(img);

    for (int i=0;i<img.pixels.length;i++) {
      c=img.pixels[i];
      this.modifiedImg.pixels[i]=c;
    }
    this.modifiedImg.updatePixels();
    this.modifiedImg.filter(BLUR, 2);
    image(this.modifiedImg, 0, 0, width, height);
  }

  public void threshold(PImage img) {
    this.init(img);

    for (int i=0;i<img.pixels.length;i++) {
      c=img.pixels[i];
      this.modifiedImg.pixels[i]=c;
    }
    this.modifiedImg.updatePixels();
    this.modifiedImg.filter(THRESHOLD, 0.4f);
    image(this.modifiedImg, 0, 0, width, height);
  }

  public void sepia(PImage img) {
    this.init(img);

    for (int i=0;i<img.pixels.length;i++) {
      c=img.pixels[i];
      r = red (c);
      b = blue (c);
      g = green (c);
      av=(r+g+b)/3;
      cc=color(av*1.2f, av*0.9f, av*0.5f);
      this.modifiedImg.pixels[i]=cc;
    }

    this.modifiedImg.updatePixels();
    image(this.modifiedImg, 0, 0, width, height);
  }

  public void invert(PImage img) {
    this.init(img);

    for (int i=0;i<img.pixels.length;i++) {
      c=img.pixels[i];
      r = red (c);
      b = blue (c);
      g = green (c);
      cc = color(255-r, 255-g, 255-b);
      this.modifiedImg.pixels[i]=cc;
    }// end for

    this.modifiedImg.updatePixels();
    image(this.modifiedImg, 0, 0, width, height);
  }

  public void posterize(PImage img) {
    this.init(img);

    for (int i=0;i<img.pixels.length;i++) {
      c=img.pixels[i];
      this.modifiedImg.pixels[i]=c;
    }
    this.modifiedImg.updatePixels();
    this.modifiedImg.filter(POSTERIZE, 2);
    image( this.modifiedImg, 0, 0, width, height);
  }

  public void warhol1(PImage img) {
    this.init(img);

    for (int i=0;i<img.pixels.length;i++) {
      c=img.pixels[i];
      r = red (c);
      b = blue (c);
      g = green (c);
      av=(r+g+b)/3;
      if (av>128) {
        // cc=color(av*1.2,av*0.9,av*0.5);}
        cc=color(av*5, av*0.5f, av*0.5f);
      }
      else {
        cc=color(255, 255, 0);
      }
      this.modifiedImg.pixels[i]=cc;
    }//end for

    this.modifiedImg.updatePixels();
    image(this.modifiedImg, 0, 0, width, height);
  }

  public void warhol2(PImage img) {
    this.init(img);

    for (int i=0;i<img.pixels.length;i++) {
      c=img.pixels[i];
      r = red (c);
      b = blue (c);
      g = green (c);
      av = (r+g+b)/3;
      if (av<20) {
        th1=255;
        th2=0;
        th3=0;
      }
      else {
        if (av>128) {
          th1=100;
          th2=255;
          th3=0;
        }
        else {
          th1=255;
          th2=255;
          th3=0;
        }
      }
      cc = color(th1, th2, th3);
      this.modifiedImg.pixels[i]=cc;
    }

    this.modifiedImg.updatePixels();
    image(this.modifiedImg, 0, 0, width, height);
  }
}//end class

class Menu {
  PFont myFont;
  String[] fontList = PFont.list();
  int buttonSize;

  Menu(int buttonSize) {
    myFont = createFont("Arial", 18);
    textFont(myFont);
    this.buttonSize = buttonSize;
  }

  public void createMainMenu(ArrayList buttons) {    
    MenuButton[] menuButtons = new MenuButton[buttons.size()];
    for (int i = 0; i<buttons.size();i++) {
      menuButtons[i] = new MenuButton((String)buttons.get(i), i, this.buttonSize);
    }
  }

  public void createSubmenu(String[] subbuttons, int x) {
    SubmenuButton[] submenuButtons = new SubmenuButton[subbuttons.length];
    for (int i = 0; i<submenuButtons.length;i++) {
      submenuButtons[i] = new SubmenuButton(subbuttons[i], x, i+1, this.buttonSize);
    }
  }
  
  public void writeCredits(){
    smooth();
    fill(255);
    text("FotoFasto 1.0", 5, 150);
    text("Software created by Elodie Rafalimanana \u00a9 2009", 5, 180);
    text("Using Processing 1.5.1", 5, 210);
  }
}

class MenuButton {
  MenuButton(String btnText, int btnIndex, int buttonSize) {
    stroke (0, 0, 0);
    fill (255, 255, 255);
    rect (btnIndex*buttonSize, 0, buttonSize, buttonSize/3);
    fill(0);
    text(btnText, 5+btnIndex*buttonSize, 25);
  }
}

class SubmenuButton {
  SubmenuButton(String btnText, int xIndex, int yIndex, int buttonSize) {
    stroke (0, 0, 0, 50);
    fill (255, 255, 255, 100);
    rect (buttonSize*xIndex, yIndex*buttonSize/3, buttonSize, buttonSize/3);
    if (yIndex == 1)
      fill(140, 0, 0);//First entry in red 
    else
      fill(0);
    text(btnText, 5+xIndex*buttonSize, 25+(yIndex*buttonSize/3));
  }
}

class Transform {
  PImage modifiedImg;
  int c;

  Transform() {
  }

  public void init(PImage img) {
    img.loadPixels();
    this.modifiedImg = createImage(img.width, img.height, RGB);
    this.modifiedImg.loadPixels();
  }

  public void flip(PImage img) {   
    this.init(img);

    for (int i=0; i<img.width; i++)
      for (int j=0; j<img.height; j++) {
        c = img.get(i, j);
        this.modifiedImg.set(i, img.height-j, c);
      }

    this.modifiedImg.updatePixels();
    image(this.modifiedImg, 0, 0, width, height);
  }

  public void rotate(PImage img) {
    this.init(img);

    for (int i=0; i<img.width; i++)
      for (int j=0; j<img.height; j++) {
        c = img.get(i, j);
        this.modifiedImg.set(j, i, c);
      }

    this.modifiedImg.updatePixels(); 
    image( this.modifiedImg, 0, 0, width, height);
  }

  public void mirror(PImage img) {
    this.init(img);

    for (int i=0; i<img.width; i++)
      for (int j=0; j<img.height; j++) {
        c = img.get(i, j);
        this.modifiedImg.set(img.width-i, j, c);
      }

    this.modifiedImg.updatePixels();
    image(this.modifiedImg, 0, 0, width, height);
  }
}

  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#F0F0F0", "FotoFasto" });
  }
}
